#include <vcl.h>
#pragma hdrstop

#include "Focus.h"
#include "kopicMain.h"
#pragma resource "*.dfm"

extern KUN_CODE *kunCode;
extern TForm1 *Form1;
TOKRightDlg *OKRightDlg;

__fastcall TOKRightDlg::TOKRightDlg(TComponent* AOwner): TForm(AOwner), COMMA(","), SEPARATOR(" / ") {
    Label1->Top = 38;    Edit1->Top = 38;   
    Label2->Top = 66;    Edit2->Top = 66;   
    Label3->Top = 94;    Edit3->Top = 94;   
    Label4->Top =  122;  Edit4->Top =  122; 

    Label1->Left = 7; Label2->Left = 7; Label3->Left = 7; Label4->Left = 7;
    Edit1->Left = 71; Edit2->Left = 71; Edit3->Left = 71; Edit4->Left = 71;

    Label1->Width = 56; Label2->Width = 56; Label3->Width = 56; Label4->Width = 56;
    Edit1->Width = 56; Edit2->Width = 56; Edit3->Width = 56; Edit4->Width = 56;

    Label1->Height = 20; Label2->Height = 20; Label3->Height = 20; Label4->Height = 20;
    Edit1->Height = 20; Edit2->Height = 20; Edit3->Height = 20; Edit4->Height = 20;

    Label1->Caption = "Left";
    Label2->Caption = "Top";
    Label3->Caption = "Right";
    Label4->Caption = "Bottom";

    data_height = kunCode->data_height;
    data_width = kunCode->data_width;
    focus_left = 0;
    focus_top = 0;
    focus_right = data_width;
    focus_bottom = data_height;
}

void __fastcall TOKRightDlg::OKBtnClick(TObject *Sender) {
    using namespace std;

    char *stop;
    focus_left = (int)strtol( Edit1->Text.c_str(), &stop, 10);
    if(focus_left < 0) {
        focus_left = 0;
    } else if(focus_left >= data_width) {
        focus_left = data_width - 1;
    }

    focus_top = (int)strtol( Edit2->Text.c_str(), &stop, 10);
    if(focus_top < 0) {
        focus_top = 0;
    } else if(focus_top >= data_height) {
        focus_top = data_height - 1;
    }

    focus_right = (int)strtol( Edit3->Text.c_str(), &stop, 10);
    if(focus_right < 1) {
        focus_right = 1;
    } else if(focus_right > data_width) {
        focus_right = data_width;
    }

    focus_bottom = (int)strtol( Edit4->Text.c_str(), &stop, 10);
    if(focus_bottom < 1) {
        focus_bottom = 1;
    } else if(focus_bottom > data_height) {
        focus_bottom = data_height;
    }

// Checking if the focus rectangle has enough width.
    if( focus_right - focus_left < 1 ) {
        focus_left = 0;
        focus_right = data_width;
    }

// Checking if the focus rectangle has enough height.
    if( focus_bottom - focus_top < 1 ) {
        focus_top = 0;
        focus_bottom = data_height;
    }

    stringstream os;
    os << focus_left << COMMA << focus_top << SEPARATOR << focus_right << COMMA << focus_bottom;
    string s = os.str();
    Form1->focussing(s, focus_left, focus_top, focus_right, focus_bottom);
}

