#ifndef SPLIT_H
#define SPLIT_H

#define SPLIT_ARRAY_SIZE 128
#include <string>

class Split {
    int argument_count;
    std::string *s[SPLIT_ARRAY_SIZE];

public:
    int count() const {
        return argument_count;
    }

    int argumentLength(int i) {
        std::string r = *s[i];
        int length = r.length();
        return length;
    }

    std::string argument(int i) const {
        return *s[i];
    }

    Split(char *p, const char *gap);
    Split(char *p, const char *gap, bool exe);
    ~Split();
};

#endif // SPLIT_H
