#include <vcl.h>
#pragma hdrstop

#include "kun.h"
#include "rannuText.h"
#include "Version.h"
#pragma resource "*.dfm"

TOKHelpBottomDlg *OKHelpBottomDlg;

__fastcall TOKHelpBottomDlg::TOKHelpBottomDlg(TComponent* AOwner): TOKBottomDlg(AOwner) {
    Height = VERSION_HEIGHT;
    Width = VERSION_WIDTH;
    setVersion(VERSION);
}

void __fastcall TOKHelpBottomDlg::BitBtn1Click(TObject *Sender) {
    helpHandler();
}

void __fastcall TOKHelpBottomDlg::CancelBtnClick(TObject *Sender) {
    setVersion(VERSION);
}

void __fastcall TOKHelpBottomDlg::HelpBtnClick(TObject *Sender) {
    Application->HelpContext(IDH_OVERVIEW);
}

void TOKHelpBottomDlg::helpHandler() {
    executeProgram(VIEW_PDF, "");
}

void TOKHelpBottomDlg::setVersion(double d) {
    RichEdit1->Font->Color = clNavy;
    RichEdit1->Font->Name = "System";
    RichEdit1->Font->Size = 14;

    const AnsiString COPYRIGHT("Copyright 2017 Sogaya\r\nVersion ");
    const AnsiString v(d);
    RichEdit1->Text = COPYRIGHT + v;
    RichEdit1->Visible = true;

    RichEdit1->SelectAll();
    RichEdit1->CopyToClipboard();
}

